# モジュール宣言/変数初期化
use strict;
my %cf;
#┌─────────────────────────────────
#│  PETIT BOARD v5.4 (2003/01/10)
#│  Copyright(C) Kent Web 2003
#│ http://www.kent-web.com/
#└─────────────────────────────────
$cf{version} = 'PETIT BOARD v9.0 LOCK';
#┌─────────────────────────────────
#│ [注意事項]
#│ 1. このプログラムはフリーソフトです。このプログラムを使用した
#│    いかなる損害に対して作者は一切の責任を負いません。
#│ 2. 設置に関する質問はサポート掲示板にお願いいたします。
#│    直接メールによる質問は一切お受けいたしておりません。
#└─────────────────────────────────
# REBUILD(改造)
#┌─────────────────────────────────
#│  PETIT BOARD v9.0 LOCK : init.cgi - 2023/06/09
#│  Edited by TRANSFORM Since 2012
#│  http://www.transformsite.com/
#└─────────────────────────────────

#===========================================================
# ■ 設定項目
#===========================================================

# パスワード制限をする場合入室パスワード設定
# → 空欄の場合はパスワード制限なし
$cf{enter_pwd} = '0123';

# パスワード制限時のセッションの許容時間（分単位）
# → 入室後からアクセス可能時間
$cf{sestime} = 60;

# 掲示板タイトル
$cf{bbs_title} = "PETIT BOARD v9.0 LOCK";

# カウンタファイル【サーバパス】
$cf{cntfile} = './data/count.dat';

# 本体ファイル【URLパス】
$cf{bbs_cgi} = './petit.cgi';

# 更新ファイル【URLパス】
$cf{regist_cgi} = './regist.cgi';

# 管理ファイル【URLパス】
$cf{admin_cgi} = './admin.cgi';

# データファイル【サーバパス】
$cf{logfile} = './data/log.cgi';

# データディレクトリ【サーバパス】
$cf{datadir} = './data';

# セッションファイル【サーバパス】
$cf{sesfile} = './data/ses.cgi';

# テンプレートディレクトリ【サーバパス】
$cf{tmpldir} = './tmpl';

# 共通ディレクトリ【URLパス】
$cf{cmnurl} = './cmn';

# 戻り先【URLパス】
$cf{homepage} = "../index.html";

# 最大記録記事数
$cf{max} = 300;

# 「最新記事TOP(リンク数)」に掲載するタイトルリンクの数
$cf{max_topics} = 5;

#グラデーションの使用 (1 = yes , 0 = no)
$cf{grad} = 1;

#グラデーション指定文字
$cf{gradstr} = '♪';

#グラデーション開始色
$cf{GradStartColor} = '#2666B2 #FFB219 #ff9999 #33cc66 #ff0000 #660066 #000000 #E89498 #00ccff #004080 #ffcc00 #cc99cc #32cd32 #008080 #008db3 #00e61a #d0d0b8 #99CCFF';

#グラデーション中間色
$cf{GradMidColor} = '#98B8F0 #ffff66 #D94677 #339933 #FFD290 #9E9CC5 #8C8C8C #FFBE68 #CEEEFF #7E7E3F #3399ff #685C70 #FFCC66 #FFCC33 #bbdbf3 #D0FBA6 #6E6E90 #f5b2b2';

#グラデーション終了色
$cf{GradEndColor} = '#33ccff #ff99cc #ffcc99 #99ff99 #333399 #cc00ff #CCCCCC #00C0F0 #ccccff #cc6600 #99ccff #cc9966 #ccffff #E29399 #f39800 #e6e61a #C3C3D4 #ffedab';

#グラデーション名前
$cf{GradName}        = 'マリーン ディブレイク ウォーム グラスランド サンセット ミッドナイト モノトーン ファニー シャインレイン ロンリネス シーサイド フォール キッド ミッドサマー モーニング スプリング コールド ドリーミー';

# タイトル背景の設定（半角スペースで区切る）
$cf{colors_b} = '#007bbb #2ca9e1 #1e50a2 #3e62ad #f7b977 #ee836f #f8b500 #f39800 #79c06e #417038 #5f6527 #9fc24d #a4d5bd #7b5544 #6a1917 #941f57 #ea5550 #d83473 #47266e #a688bd #6c2463 #da81b2 #e95464 #e3acae #736d71 #24140e #a4a8d4 #008db7 #00608d #294366';
$cf{colors_b2}= '紺碧 天色 瑠璃色 杜若色 アプリコット 珊瑚朱色  山吹色 マリーゴールド スペアミント スピナッチグリーン オリーブグリーン リーフグリーン スプレイグリーン ココアブラウン マルーン クラレット レッド アザレ ディープロイヤルパープル ラベンダーモーブ プラム オーキッドピンク ローズ ピンクアーモンド スチールグレイ ランプブラック ブルーラベンダー セルリアンブルー マドンナブルー プチボードブルー';

# 返信がつくと親記事をトップへ移動 (0=no 1=yes)
$cf{topsort} = 1;

# ミニカウンタの設置
# → 0=no 1=テキスト 2=画像
$cf{counter} = 1;

# ミニカウンタの桁数
$cf{mini_fig} = 6;

# テキストのとき：ミニカウンタの色
$cf{cntcol} = "#fff";

# 記事 [タイトル] 部の長さ (全角文字換算)
$cf{sub_len} = 30;

# 記事 [お名前] 部の長さ (全角文字換算)
$cf{name_len} = 8;

# １ページ当たりの記事表示数 (親記事)
$cf{pg_max} = 5;

# 投稿があるとメール通知する (sendmail必須)
# 0 : 通知しない
# 1 : 通知する
$cf{mailing} = 1;

# メールアドレス(メール通知する時)
$cf{mailto} = 'xxx@xxx.xx';

# sendmailパス（メール通知する時）
$cf{sendmail} = '/usr/lib/sendmail';

# sendmailの -fコマンドが必要な場合
# 0=no 1=yes
$cf{sendm_f} = 0;

# 文字色の設定
# →　スペースで区切る
$cf{colors} = '#626063 #898989 #a4c1d7 #68a4d9 #8d93c8 #79c06e #618e34 #fcc800 #f39800 #98605e #ea5550 #47266e #a688bd #e95464 #e3acae #c9caca';

# 返信用文字色
$cf{colors_res} = '#000000 #4d5aaf #009999 #3399ff #9370db #9900ff #ff0000 #ff6666 #f09199 #ff6600 #eebb00 #00cc00 #028760 #993300 #666666';
$cf{colors_res2} = '黒 紺桔梗 青緑 空色 薄紫 紫 赤 鮭桃色 桃色 橙色 山吹色 黄緑 常磐色 茶色 灰色';

# URLの自動リンク (0=no 1=yes)
$cf{autolink} = 1;

# ホスト取得方法
# 0 : gethostbyaddr関数を使わない
# 1 : gethostbyaddr関数を使う
$cf{gethostbyaddr} = 0;

# アクセス制限（半角スペースで区切る、アスタリスク可）
# → 拒否ホスト名を記述（後方一致）【例】*.anonymizer.com
$cf{deny_host} = '';
# → 拒否IPアドレスを記述（前方一致）【例】210.12.345.*
$cf{deny_addr} = '106.154.158.187';

# １回当りの最大投稿サイズ (bytes)
$cf{maxdata} = 51200;

# 週表示
$cf{week} = ['日','月','火','水','木','金','土'];

# 記事の更新は method=POST 限定する場合（セキュリティ対策）
# → 0=no 1=yes
$cf{postonly} = 1;

# 投稿制限（セキュリティ対策）
# 0 : しない
# 1 : 同一IPアドレスからの投稿間隔を制限する
# 2 : 全ての投稿間隔を制限する
$cf{regCtl} = 0;

# 制限投稿間隔（秒数）
# → $cf{regCtl} での投稿間隔
$cf{wait} = 0;

# 禁止ワード
# → コンマで区切って複数指定（例）$cf{no_word} = 'アダルト,出会い';
$cf{no_wd} = 'ブランド品 href= [url= [/url],コピー';

# 日本語チェック（投稿時日本語が含まれていなければ拒否する）
# 0=No  1=Yes
$cf{jp_wd} = 1;

# URL個数チェック
# → 投稿コメント中に含まれるURL個数の最大値
$cf{urlnum} = 2;

# クッキーID名（特に変更しなくてよい）
$cf{cookie_id}  = "petitboard";  # フォーム入力
$cf{cookie_id3} = "petit_pwd";  # パスワード制限

# 管理パスワードの最大間違い制限
# → この回数以上パスワードを間違うとロックします
$cf{max_failpass} = 5;

# 管理パスワードのロック期間：自動解除を日数で指定
# → この値を 0 にすると自動解除しません。
$cf{lock_days} = 14;

# -------------------------------------------------------------- #
# [ 以下は「過去ログ」機能を使用する場合の設定 ]
#
# 過去ログ生成
# → 0=no 1=yes
$cf{pastkey} = 1;

# 過去ログ用NOファイル【サーバパス】
$cf{nofile}  = './data/pastno.dat';

# 過去ログのディレクトリ【サーバパス】
# → パスの最後に / をつけない
$cf{pastdir} = './data/past';

# 過去ログ１ファイルの行数
# → この行数を超えると次ページを自動生成します
$cf{pastmax} = 600;

# -------------------------------------------------------------- #
# [ 以下は「画像認証機能」機能を使用する場合の設定 ]
#
# 画像認証機能の使用
# 0 : しない
# 1 : ライブラリ版（pngren.pl）
# 2 : モジュール版（GD::SecurityImage + Image::Magick）→ Image::Magick必須
$cf{use_captcha} = 1;

# 認証用画像生成ファイル【URLパス】
$cf{captcha_cgi} = './captcha.cgi';

# 画像認証プログラム【サーバパス】
$cf{captcha_pl} = './lib/captcha.pl';
$cf{captsec_pl} = './lib/captsec.pl';
$cf{pngren_pl}  = './lib/pngren.pl';

# 画像認証機能用暗号化キー（暗号化/復号化をするためのキー）
# → 適当に変更してください。
$cf{captcha_key} = 'captpetit';

# 投稿キー許容時間（分単位）
# → 投稿フォーム表示後、送信ボタンが押されるまでの可能時間。
$cf{cap_time} = 30;

# 投稿キーの文字数
# ライブラリ版 : 4～8文字で設定
# モジュール版 : 6～8文字で設定
$cf{cap_len} = 6;

# 画像/フォント格納ディレクトリ【サーバパス】
$cf{bin_dir} = './lib/bin';

# [ライブラリ版] 画像ファイル [ ファイル名のみ ]
$cf{si_png} = "colorful_b.png";

# [モジュール版] 画像フォント [ ファイル名のみ ]
$cf{font_ttl} = "tempest.ttf";

#===========================================================
# ■ 設定完了
#===========================================================

# 設定内容を返す
sub set_init {
	return %cf;
}

#-----------------------------------------------------------
#  フォームデコード
#-----------------------------------------------------------
sub parse_form {
	my ($buf,%in);
	if ($ENV{REQUEST_METHOD} eq "POST") {
		error('受理できません') if ($ENV{CONTENT_LENGTH} > $cf{maxdata});
		read(STDIN, $buf, $ENV{CONTENT_LENGTH});
	} else {
		$buf = $ENV{QUERY_STRING};
	}
	foreach ( split(/&/, $buf) ) {
		my ($key,$val) = split(/=/);
		$key =~ tr/+/ /;
		$key =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("H2", $1)/eg;
		$val =~ tr/+/ /;
		$val =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("H2", $1)/eg;

		# 無効化
		$key =~ s/[<>"'&\r\n]//g;
		$val =~ s/&/&amp;/g;
		$val =~ s/</&lt;/g;
		$val =~ s/>/&gt;/g;
		$val =~ s/"/&quot;/g;
		$val =~ s/'/&#39;/g;
		$val =~ s|\r\n|<br />|g;
		$val =~ s|[\r\n]|<br />|g;

		$in{$key} .= "\0" if (defined($in{$key}));
		$in{$key} .= $val;
	}
	return %in;
}

#-----------------------------------------------------------
#  エラー画面
#-----------------------------------------------------------
sub error {
	my $err = shift;
	
	open(IN,"$cf{tmpldir}/error.html") or die;
	my $tmpl = join('', <IN>);
	close(IN);
	
	$tmpl =~ s/!error!/$err/g;
	$tmpl =~ s|!bbs_css!|$cf{cmnurl}/bbs.css|g;
	
	print "Content-type: text/html; charset=utf-8\n\n";
	print $tmpl;
	# フッタ
	footer();
	exit;
}

#-----------------------------------------------------------
#  パスワード制限
#-----------------------------------------------------------
sub passwd {
	my %in = @_;

	# 入室フォーム指定のとき
	if ($in{mode} eq 'enter') { pwd_form(); }

	# 時間取得
	my $now = time;

	# ログインのとき
	if ($in{login}) {
		# 認証
		if ($in{pw} ne $cf{enter_pwd}) { error("認証できません"); }

		# セッション発行
		my @wd = (0 .. 9, 'a' .. 'z', 'A' .. 'Z', '_');
		my $ses;
		srand;
		for (1 .. 25) {	$ses .= $wd[int(rand(@wd))]; }

		# セッション更新
		my @log;
		open(DAT,"+< $cf{sesfile}") or error("open err: $cf{sesfile}");
		eval 'flock(DAT, 2);';
		while(<DAT>) {
			chomp;
			my ($id,$time) = split(/\t/);
			next if ($now - $time > $cf{sestime} * 60);

			push(@log,"$_\n");
		}
		unshift(@log,"$ses\t$now\n");
		seek(DAT, 0, 0);
		print DAT @log;
		truncate(DAT, tell(DAT));
		close(DAT);

		# クッキー格納
		print "Set-Cookie: $cf{cookie_id3}=$ses\n";

	# セッション確認
	} else {

		# クッキー取得
		my $cook = $ENV{HTTP_COOKIE};

		# 該当IDを取り出す
		my %cook;
		foreach ( split(/;/, $cook) ) {
			my ($key,$val) = split(/=/);
			$key =~ s/\s//g;
			$cook{$key} = $val;
		}

		# クッキーなし
		if ($cook{$cf{cookie_id3}} eq '') { pwd_form(); }

		# ログオフのとき
		if ($in{mode} eq 'logoff') {

			my @log;
			open(DAT,"+< $cf{sesfile}") or error("open err: $cf{sesfile}");
			eval 'flock(DAT, 2);';
			while(<DAT>) {
				my ($id,undef) = split(/\t/);
				next if ($cook{$cf{cookie_id3}} eq $id);

				push(@log,$_);
			}
			seek(DAT, 0, 0);
			print DAT @log;
			truncate(DAT, tell(DAT));
			close(DAT);

			if ($ENV{PERLXS} eq "PerlIS") {
				print "HTTP/1.0 302 Temporary Redirection\r\n";
				print "Content-type: text/html\n";
			}
			print "Set-Cookie: $cf{cookie_id3}=;\n";
			print "Location: $cf{homepage}\n\n";
			exit;
		}

		# セッションチェック
		my $flg;
		open(DAT,"$cf{sesfile}") or error("open err: $cf{sesfile}");
		while(<DAT>) {
			chomp;
			my ($id,$time) = split(/\t/);

			if ($cook{$cf{cookie_id3}} eq $id) {
				# 時間オーバー
				if ($now - $time > $cf{sestime} * 60) {
					$flg = -1;
				# OK
				} else {
					$flg = 1;
				}
				last;
			}
		}
		close(DAT);

		# 時間オーバー
		if ($flg == -1) {
			my $msg = qq|入室時間が経過しました。再度ログインしてください<br>\n|;
			$msg .= qq|[<a href="$cf{bbs_cgi}?mode=enter">ログイン</a>]\n|;
			error($msg);

		# セッション情報なし
		} elsif (!$flg) {
			pwd_form();
		}
	}
}

#-----------------------------------------------------------
#  入室画面
#-----------------------------------------------------------
sub pwd_form {
	open(IN,"$cf{tmpldir}/enter.html") or error('open err: enter.html');
	my $tmpl = join('', <IN>);
	close(IN);
	
	$tmpl =~ s/!bbs_cgi!/$cf{bbs_cgi}/g;
	$tmpl =~ s|!bbs_css!|$cf{cmnurl}/bbs.css|g;
	$tmpl =~ s/!bbs_title!/$cf{bbs_title}/g;
	
	print "Content-type: text/html; charset=utf-8\n\n";
	footer($tmpl,'pform');
}



1;

