#!/usr/bin/perl

#┌─────────────────────────────────
#│  PETIT BOARD v5.4 petit.cgi (2003/01/10)
#│  Copyright(C) Kent Web 2003
#│  http://www.kent-web.com/
#└─────────────────────────────────
# REBUILD(改造)
#┌─────────────────────────────────
#│  PETIT BOARD v9.0 LOCK : petit.cgi - 2023/06/09
#│  Edited by TRANSFORM Since 2012
#│  https://www.transformsite.com/
#└─────────────────────────────────
# モジュール宣言
use strict;
use CGI::Carp qw(fatalsToBrowser);

# 設定ファイル認識
require "./init.cgi";
my %cf = set_init();

# データ受理
my %in = parse_form();

# アクセス制限
passwd(%in) if ($cf{enter_pwd} ne '');

# 処理分岐
if ($in{mode} eq "grad") { grad_disp(); }
if ($in{mode} eq "form") { form_page(); }
if ($in{mode} eq "find") { find_data(); }
if ($in{mode} eq "note") { note_page(); }
if ($in{mode} eq "past") { past_log(); }
if ($in{mode} eq "topic") { topic_log(); }
if ($in{mode} eq "gate") { gate_form(); }
if ($in{mode} eq 'lock') { lock_form(); }
if ($in{mode} eq 'ttlback') { ttlbg_page(); }

bbs_list();

#-----------------------------------------------------------
#  記事表示部
#-----------------------------------------------------------
sub bbs_list {
	
	# 記事展開
	my ($i,@log,%res,%nam,%sub,%dat,%com,%url,%col,%rno,%upd,%grad,%lock,%color2);
	open(IN,"$cf{logfile}") or error("open err: $cf{logfile}");
	my $top = <IN>;
	while (<IN>) {
		my ($no,$reno,$date,$name,$eml,$sub,$com,$url,$host,$pw,$col,$grad,$lock,$color2) = split(/<>/);
		
		++$i if (!$reno);
		next if ($i < $in{pg} + 1);
		next if ($i > $in{pg} + $cf{pg_max});
		
		# 親記事
		if (!$reno) {
			push(@log,$no);
			$rno{$no} = 0;
			$upd{$no} = "$date<br />$name";
			
		# レス記事
		} else {
			$res{$reno} .= "$no,";
			$rno{$reno}++;
			$upd{$reno} = "$date<br />$name";
		}
		# リンク
			$name = qq|<a href="mailto:$eml">$name</a>| if ($eml);
			$url &&= qq|<a href="$url" target="_blank"><img src="$cf{cmnurl}/home.png" class="icon" alt="" /></a>|;
			$com = auto_link($com) if ($cf{autolink});

		# ハッシュ化
		$nam{$no} = $name;
		$sub{$no} = $sub;
		$dat{$no} = $date;
		$com{$no} = $com;
		$col{$no} = $col;
		$grad{$no} = $grad;
		$lock{$no} = $lock;
		$url{$no} = $url;
		$color2{$no} = $color2;
	}
	close(IN);

	# 繰越ボタン作成
	my $page_btn = make_pgbtn($i,$in{pg});

	# クッキー取得
	my @cook = get_cookie($cf{cookie_id});
	$cook[2] ||= 'http://';

	# 色選択ボタン
	my @col = split(/\s+/,$cf{colors});
	my $color;
	foreach (0 .. $#col) {
		if ($_ == $cook[3]) {
			$color .= qq|<input type="radio" name="color" value="$_" checked="checked" />|;
		} else {
			$color .= qq|<input type="radio" name="color" value="$_" />|;
		}
		$color .= qq|<span style="color:$col[$_]">■</span>\n|;
	}

	# 返信色選択ボタン
        my @resc1 = split(/\s+/, $cf{colors_res});
        my @resc2 = split(/\s+/, $cf{colors_res2});
	my $op_colors;
	foreach (0 .. $#resc1) {
		if ($cook[3] eq $resc1[$_]) {
			$op_colors .= qq|<option value="$resc1[$_]" style="color:$resc1[$_]" selected>$resc2[$_]\n|;
		} else {
			$op_colors .= qq|<option value="$resc1[$_]" style="color:$resc1[$_]">$resc2[$_]\n|;
		}
	}

	# グラデーションプルダウン
        my @grd = split(/\s+/, $cf{GradStartColor});
        my @grdn = split(/\s+/, $cf{GradName});
	my %ck;
	my $grad;
	if ($cook[4] eq "") { $cook[4] = $grdn[0]; }
	foreach (0 .. $#grd) {
                if ($cook[4] eq $_) {
			$grad .= qq|<option value="$_" style="color:$grd[$_]" selected>$grdn[$_]\n|;
		} else {
			$grad .= qq|<option value="$_" style="color:$grd[$_]">$grdn[$_]\n|;
		}
	}

	# タイトル背景プルダウン
        my @col3 = split(/\s+/, $cf{colors_b});
        my @col4 = split(/\s+/, $cf{colors_b2});
	my $color_b;
	if ($cook[5] eq "") { $cook[5] = $col3[0]; }
	foreach (0 .. $#col3) {
		if ($cook[4] eq $col3[$_]) {
			$color_b .= qq|<option value="$col3[$_]" style="color:$col3[$_]" selected>$col4[$_]</option>\n|;
		} else {
			$color_b .= qq|<option value="$col3[$_]" style="color:$col3[$_]">$col4[$_]</option>\n|;
		}
	}

	# カウンタ
	my $counter = bbs_count() if ($cf{counter});
	
	# home or logoff
	my $home = $cf{enter_pwd} eq '' ? $cf{homepage} : "$cf{bbs_cgi}?mode=logoff";
	
	# テンプレート読込
	open(IN,"$cf{tmpldir}/bbs.html") or error("open err: bbs.html");
	my $tmpl = join('', <IN>);
	close(IN);

	# テンプレート読込
	open(IN,"$cf{tmpldir}/res_form.html") or error("open err: res_form.html");
	my $res_tmpl = join('', <IN>);
	close(IN);
	
	# 画像認証非表示
	if ($cf{use_captcha} == 0) {
		$res_tmpl =~ s/<!-- captcha_begin -->.+<!-- captcha_end -->//s;
	}
	
	# グラデーションモード
	if (!$cf{grad}) {
		$res_tmpl =~ s/<!-- grad_begin -->.+?<!-- grad_end -->//sg;
	}

	my $topic = read_topic();

	# 文字置換
	$tmpl =~ s/!bbs_title!/$cf{bbs_title}/g;
	$tmpl =~ s|!icon:(\w+\.\w+)!|<img src="$cf{cmnurl}/$1" alt="" class="icon" />|g;
	$tmpl =~ s|!bbs_css!|$cf{cmnurl}/bbs.css|g;
	$tmpl =~ s|!menu_css!|$cf{cmnurl}/smoke.css|g;
	$tmpl =~ s|!bbs_js!|$cf{cmnurl}/bbs.js|g;
	$tmpl =~ s/!([a-z]+_cgi)!/$cf{$1}/g;
	$tmpl =~ s/!homepage!/$home/g;
	$tmpl =~ s/!page_btn!/$page_btn/g;
	$tmpl =~ s/!counter!/$counter/g;
	$tmpl =~ s/<!-- topic -->/$topic/;
	$tmpl =~ s/!topic_count!/$cf{max_topics}/g;
	$tmpl =~ s/!q!/$in{q}/g;
	$tmpl =~ s/<!-- op_color2 -->/$color_b/g;

	# レス用テンプレート
	my $resloop;
	open(IN,"$cf{tmpldir}/res.html") or error("open err: res.html");
	$resloop = join('', <IN>);
	close(IN);

	# テンプレート分割
	my ($head,$loop,$foot) = $tmpl =~ /(.+)<!-- loop_begin -->(.+)<!-- loop_end -->(.+)/s
			? ($1,$2,$3)
			: error("テンプレート不正");

	# 過去ログ
	if ($cf{pastkey} == 0) {
		$head =~ s/<!-- past_begin -->.+<!-- past_end -->//gs;
	}
	
	# ヘッダ表示
	print "Content-type: text/html; charset=utf-8\n\n";
	print $head;

	# 記事表示
	foreach (@log) {

		# レス
		my ($res,$n);
		foreach my $r ( split(/,/,$res{$_}) ) {
			$n++;
			my $tmp = $resloop;
			$tmp =~ s/!art-ttl!/$sub{$r}/g;
			$tmp =~ s/!res-name!/$nam{$r}/g;
			$tmp =~ s/!url!/$url{$r}/g;

		# 日付フォーマット
		my ($year,$mon,$mday,$wday,$hour,$min) = $dat{$r} =~ /^(\d{4})\/(\d{2})\/(\d{2})(\w)|(\d{2}):(\d{2})$/ && ($1,$2,$3,$4,$5,$6);
		my ($y,$m,$d) = $dat{$r} =~ /^(\d+)\/(\d+)\/(\d+)/ && ($1,$2,$3);
		my $week = get_week($y,$m,$d);
		$dat{$r} = "$m月$d日（$cf{week}[$week]曜日）$hour:$min";

			$tmp =~ s|!date!|<span style="font-size:9pt">$dat{$r}</span>|g;
			$tmp =~ s/!num!/$r/g;
			$tmp =~ s|!comment!|<span style="color:$col{$r}">$com{$r}</span>|g;
			$tmp =~ s|!icon:(\w+\.\w+)!|<img src="$cf{cmnurl}/$1" alt="" class="icon" />|g;
			$tmp =~ s/!bbs_cgi!/$cf{bbs_cgi}/g;
			$tmp =~ s|!ico_edit!|<a href="$cf{bbs_cgi}?mode=gate&no=$r"><img src="$cf{cmnurl}/edit.png" title="記事編集" alt="記事編集"></a>|g;

		if ($lock{$_} eq '1') {
			$tmp =~ s|<!-- lock_edit -->.+?<!-- /lock_edit -->||s;
		}

			$res .= $tmp;
		}

		# 返信フォーム用文字置換
		my $resform;
			my $tmp = $res_tmpl;

			# 画像認証作成
			my ($str_plain,$str_crypt);
			if ($cf{use_captcha} > 0) {
				require $cf{captcha_pl};

				($str_plain,$str_crypt) = cap::make($cf{captcha_key},$cf{cap_len});
				$tmp =~ s/!str_crypt!/$str_crypt/g;
			}

			$tmp =~ s/!([a-z]+_cgi)!/$cf{$1}/g;
			$tmp =~ s/!str_crypt!/$str_crypt/g;
			$tmp =~ s/!sub_len!/$cf{sub_len}/;
			$tmp =~ s/!reg-name!/$cook[0]/;
			$tmp =~ s/!color!/$color/g;
			$tmp =~ s/!num!/$_/g;
			#$tmp =~ s/!sub!/Re:$sub{$_}/g;
			$tmp =~ s/<!-- op_grad -->/$grad/g;
			$tmp =~ s/<!-- op_colors -->/$op_colors/g;
			$tmp =~ s/!color!/$color/g;
			$tmp =~ s|!icon:(\w+\.\w+)!|<img src="$cf{cmnurl}/$1" alt="" class="icon" />|g;
			$resform .= $tmp;

		# 親
		my $tmp = $loop;
		$tmp =~ s/!art-ttl!/$sub{$_}/g;
		$tmp =~ s/!name!/$nam{$_}/g;
		$tmp =~ s/!url!/$url{$_}/g;
		$tmp =~ s/!date!/$dat{$_}/g;
		$tmp =~ s/!num!/$_/g;
		$tmp =~ s|!comment!|<span style="color:$col[$col{$_}]">$com{$_}</span>|g;
		$tmp =~ s/<!-- res -->/$res/g;
		$tmp =~ s/!res_form!/$resform/g;
		$tmp =~ s/!bbs_cgi!/$cf{bbs_cgi}/g;
		$tmp =~ s/!res!/$rno{$_}/g;
		$tmp =~ s/!update!/$upd{$_}/g;
		$tmp =~ s/!color2!/$color2{$_}/g;
		$tmp =~ s|!ico_edit!|<a href="$cf{bbs_cgi}?mode=gate&no=$_"><img src="$cf{cmnurl}/edit.png" title="記事編集" alt="記事編集" class="icon" /></a>|g;
		$tmp =~ s|!ico_lock!|<a href="$cf{bbs_cgi}?mode=lock&no=$_"><img src="$cf{cmnurl}/password.png" title="記事ロック" alt="記事ロック" class="icon" /></a>|g;
		$tmp =~ s|!icon:(\w+\.\w+)!|<img src="$cf{cmnurl}/$1" alt="" class="icon" />|g;

		if ($lock{$_} eq '1') {
			$tmp =~ s|<!-- lock_edit -->.+?<!-- /lock_edit -->||s;
			$tmp =~ s|<!-- lock_form -->.+?<!-- /lock_form -->||s;
		} elsif ($lock{$_} == 0 || $lock{$_} == '') {
			$tmp =~ s|<!-- lock -->.+?<!-- /lock -->||s;
		}
		print $tmp;
	}

	# フッタ
	footer($foot);
}

#-----------------------------------------------------------
#  週算出
#-----------------------------------------------------------
sub get_week {
	my ($yy,$mm,$dd) = @_;
	
	if ($mm == 1 || $mm == 2) {
		$yy--;
		$mm += 12;
	}
	int( $yy + int($yy / 4) - int($yy / 100) + int($yy / 400) + int((13 * $mm + 8) / 5) + $dd ) % 7;
}

#-----------------------------------------------------------
#  タイトル背景・サンプル
#-----------------------------------------------------------
sub ttlbg_page {

	# 時間取得
	my ($date,$time) = get_time();

	# テンプレート認識
	open(IN,"$cf{tmpldir}/ttlbg_color.html") or &error("open err: ttlbg_color.html");
	my $tmpl = join('', <IN>);
	close(IN);

	$tmpl =~ s/!bbs_title!/$cf{bbs_title}/g;
	$tmpl =~ s|!icon:(\w+\.\w+)!|<img src="$cf{cmnurl}/$1" alt="" class="icon" />|g;
	$tmpl =~ s|!bbs_css!|$cf{cmnurl}/joyful.css|g;
	$tmpl =~ s|!mob_css!|$cf{cmnurl}/joyful-mobile.css|g;
	$tmpl =~ s|!bbs_js!|$cf{cmnurl}/bbs.js|g;

	# テンプレート分割
	my ($head,$loop,$foot);
	if ($tmpl =~ /(.+)<!-- loop_begin -->(.+)<!-- loop_end -->(.+)/s) {
		($head,$loop,$foot) = ($1, $2, $3);
	} else {
		&error("テンプレートが不正です");
	}

	# 文字置換
	foreach ($head, $foot) {
		s/!([a-z]+_cgi)!/$cf{$1}/g;
		s/!version!/$cf{version}/g;
	}

	# 画面展開
	print "Content-type: text/html; charset=utf-8\n\n";
	print $head;

        my @col3 = split(/\s+/, $cf{colors_b});
        my @col4 = split(/\s+/, $cf{colors_b2});
	foreach (0 .. $#col3) {

		my $tmp = $loop;
		$tmp =~ s|!color_b!|<div class="art_border"><h4 id="bg" style="background:$col3[$_];">$date</h4><span style="color:$col3[$_]; font-size:10.5pt">タイトル背景色<br>SAMPLE</span></div>|g;
		$tmp =~ s/!name!/$col4[$_]/g;
		print $tmp;
	}

	# フッタ
	&footer($foot);
	exit;
}

#-----------------------------------------------------------
#  時間取得[タイトル背景サンプル]
#-----------------------------------------------------------
sub get_time {
	$ENV{TZ} = "JST-9";
	my $time = time;
	my ($min,$hour,$mday,$mon,$year,$wday) = (localtime($time))[1..6];
	my @week = qw(Sun Mon Tue Wed Thu Fri Sat);
	
	# 日時のフォーマット
	my $date = sprintf("%04d/%02d/%02d(%s) %02d:%02d",
			$year+1900,$mon+1,$mday,$week[$wday],$hour,$min);
	
	return ($date, $time);
}

#-----------------------------------------------------------
#  記事ロックフォーム
#-----------------------------------------------------------
sub lock_form {

	$in{no} =~ s/\D//g;

	# 記事
	my ($name,$pwd,$lock);
	open(IN,"$cf{logfile}") or &error("open err: $cf{logfile}");
	my $top = <IN>;
	while (<IN>) {
		my ($no,$reno,$date,$name,$eml,$sub,$com,$url,$host,$pw,$col,$grad,$lock,$color2) = split(/<>/);

	if ($in{no} == $no) {
		$name = $name;
		$pwd = $pw;
		$lock = $lock;
		last;
		}
	}
	close(IN);

	# パスワード未設定
	error("この記事はパスワード未設定のため編集できません") if ($pwd eq '');

	my ($no,$reno,$date,$name,$eml,$sub,$com,$url,$host,$pw,$col,$grad,$lock,$color2) = split(/<>/);
		$name = qq|<a href="mailto:$eml">$name</a>| if ($eml);
		$url &&= qq|<a href="$url" target="_blank"><img src="$cf{ico_home}" class="icon"></a>|;
		$com = auto_link($com) if ($cf{autolink});

		#if (length($com) > 135) { $com = substr($com,0,140); $com .= '.....(略)'; }

	my @col = split(/\s+/, $cf{colors});

	open(IN,"$cf{tmpldir}/lock_form.html") or &error("open err: lock_form.html");
	my $tmpl = join('', <IN>);
	close(IN);

	# 文字置換
	$tmpl =~ s/!bbs_title!/$cf{bbs_title}/g;
	$tmpl =~ s|!ico:(\w+\.\w+)!|<img src="$cf{cmnurl}/$1" alt="" class="icon" />|g;
	$tmpl =~ s|!bbs_css!|$cf{cmnurl}/bbs.css|g;
	$tmpl =~ s|!bbs_js!|$cf{cmnurl}/bbs.js|g;
	$tmpl =~ s/!([a-z]+_cgi)!/$cf{$1}/g;
	$tmpl =~ s/!num!/$no/g;
	$tmpl =~ s/!sub!/$sub/g;
	$tmpl =~ s/!name!/$name/g;
	$tmpl =~ s/!color2!/$color2/g;

	if (!$reno) {
		$tmpl =~ s|!comment!|<span style="color:$col[$col]">$com</span>|g;
	} else {
		$tmpl =~ s|!comment!|<span style="color:$col">$com</span>|g;
	}

	if ($lock == 1) {
		$tmpl =~ s|!lock_com!||g;
		$tmpl =~ s|!open_com!|<span style="color:#00a968">以下の投稿記事のロックを解除することが出来ます</span>|g;
	} 
	if ($lock == 0)  {
		$tmpl =~ s|!lock_com!|<span style="color:#dc143c">以下の投稿記事をロックして閉じることが出来ます</span>|g;
		$tmpl =~ s|!open_com!||g;
	}


	print "Content-type: text/html; charset=utf-8\n\n";
	print $tmpl;

	# フッタ
	footer();

	exit;
}

#-----------------------------------------------------------
#  パスワードフォーム
#-----------------------------------------------------------
sub gate_form {

	$in{no} =~ s/\D//g;

	# 記事
	my ($name,$pwd);
	open(IN,"$cf{logfile}") or &error("open err: $cf{logfile}");
	my $top = <IN>;
	while (<IN>) {
		my ($no,$reno,$date,$name,$eml,$sub,$com,$url,$host,$pw,$col,$grad,$lock,$color2) = split(/<>/);

	if ($in{no} == $no) {
		$name = $name;
		$pwd = $pw;
		last;
		}
	}
	close(IN);

	# パスワード未設定
	error("この記事はパスワード未設定のため編集できません") if ($pwd eq '');

	my ($no,$reno,$date,$name,$eml,$sub,$com,$url,$host,$pw,$col,$grad,$lock,$color2) = split(/<>/);
		$name = qq|<a href="mailto:$eml">$name</a>| if ($eml);
		$url &&= qq|<a href="$url" target="_blank"><img src="$cf{ico_home}" class="icon"></a>|;
		$com = auto_link($com) if ($cf{autolink});

		#if (length($com) > 150) { $com = substr($com,0,160); $com .= '.....(略)'; }

	my @col = split(/\s+/, $cf{colors});

	open(IN,"$cf{tmpldir}/gate.html") or &error("open err: gate.html");
	my $tmpl = join('', <IN>);
	close(IN);

	# 文字置換
	$tmpl =~ s/!bbs_title!/$cf{bbs_title}/g;
	$tmpl =~ s|!ico:(\w+\.\w+)!|<img src="$cf{cmnurl}/$1" alt="" class="icon" />|g;
	$tmpl =~ s|!bbs_css!|$cf{cmnurl}/bbs.css|g;
	$tmpl =~ s|!menu_css!|$cf{cmnurl}/smoke.css|g;
	$tmpl =~ s|!bbs_js!|$cf{cmnurl}/bbs.js|g;
	$tmpl =~ s/!([a-z]+_cgi)!/$cf{$1}/g;
	$tmpl =~ s/!num!/$no/g;
	$tmpl =~ s/!sub!/$sub/g;
	$tmpl =~ s/!name!/$name/g;
	$tmpl =~ s/!color2!/$color2/g;

	if (!$reno) {
		$tmpl =~ s|!comment!|<span style="color:$col[$col]">$com</span>|g;
	} else {
		$tmpl =~ s|!comment!|<span style="color:$col">$com</span>|g;
	}

	print "Content-type: text/html; charset=utf-8\n\n";
	print $tmpl;

	# フッタ
	footer();

	exit;
}

#-----------------------------------------------------------
#  最新記事INDEX作成
#-----------------------------------------------------------
sub read_topic {

	# 最新記事リスト表示
	my ($i,$topic,@top_ttl);
	open(IN,"$cf{logfile}") or error("open err: $cf{logfile}");
	my $top = <IN>;
	while (<IN>) {
		my ($no,$reno,$date,$name,$eml,$sub,$com,$url,$host,$pw,$col,$grad,$lock,$color2) = split(/<>/);
		if (!$reno) {
			if (defined($no)) {push(@top_ttl,$_); }

		# 文字カット
			if (length($sub) > 16) {
				$sub = substr($sub,0,24) . '...';
			}
		$i++;
		last if ($i >= $cf{max_topics} + 1);

		$topic .= qq|○ <a href="$cf{bbs_cgi}?mode=topic&no=$no">$sub</a>&nbsp;&nbsp;|;
		}
	}
	close(IN);

	foreach my $ttl (@top_ttl) {
		my ($no,$reno,$date,$name,$eml,$sub,$com,$url,$host,$pw,$col,$grad,$lock,$color2) = split(/<>/, $ttl);

			$topic = qq|$topic\n|;
	}
	# 結果を返す
	return $topic;
}

#-----------------------------------------------------------
#  記事閲覧 (最新記事リスト)
#-----------------------------------------------------------
sub topic_log {
	$in{no} =~ s/\D//g;

	my ($resub,@log,@res);
	open(IN,"$cf{logfile}") or &error("open err: $cf{logfile}");
	my $top = <IN>;
	while (<IN>) {
		my ($no,$reno,$date,$name,$eml,$sub,$com,$url,$host,$pw,$col,$grad,$lock,$color2) = split(/<>/);

		if ($in{no} == $no) {
			push(@log,$_);

			# タイトル名
			if ($sub =~ /^Re:/) {
				$resub = $sub;
			} else {
				$resub = "Re: $sub";
			}
		} elsif ($in{no} == $reno) {
			push(@res,$_);
		}
	}
	close(IN);

	my @cook = get_cookie($cf{cookie_id});
	# 色選択ボタン
	my @col = split(/\s+/,$cf{colors});
	my $color;
	foreach (0 .. $#col) {
		if ($_ == $cook[3]) {
			$color .= qq|<input type="radio" name="color" value="$_" checked="checked" />|;
		} else {
			$color .= qq|<input type="radio" name="color" value="$_" />|;
		}
		$color .= qq|<span style="color:$col[$_]">■</span>\n|;
	}

	# 返信色選択ボタン
        my @resc1 = split(/\s+/, $cf{colors_res});
        my @resc2 = split(/\s+/, $cf{colors_res2});
	my $op_colors;
	foreach (0 .. $#resc1) {
		if ($cook[3] eq $resc1[$_]) {
			$op_colors .= qq|<option value="$resc1[$_]" style="color:$resc1[$_]" selected>$resc2[$_]\n|;
		} else {
			$op_colors .= qq|<option value="$resc1[$_]" style="color:$resc1[$_]">$resc2[$_]\n|;
		}
	}

	# テンプレート認識
	open(IN,"$cf{tmpldir}/read.html") or &error("open err: read.html");
	my $tmpl = join('', <IN>);
	close(IN);

	# 文字置き換え
	$tmpl =~ s/!([a-z]+_cgi)!/$cf{$1}/g;
	$tmpl =~ s/!bbs_title!/$cf{bbs_title}/g;
	$tmpl =~ s|!icon:(\w+\.\w+)!|<img src="$cf{cmnurl}/$1" alt="" class="icon" />|g;
	$tmpl =~ s|!bbs_css!|$cf{cmnurl}/bbs.css|g;
	$tmpl =~ s|!menu_css!|$cf{cmnurl}/smoke.css|g;
	$tmpl =~ s|!bbs_js!|$cf{cmnurl}/bbs.js|g;
	$tmpl =~ s/!([a-z]+_cgi)!/$cf{$1}/g;
	$tmpl =~ s/!topic_count!/$cf{max_topics}/g;

	# テンプレート分割
	my ($head,$loop,$foot) = $tmpl =~ /(.+)<!-- loop_begin -->(.+)<!-- loop_end -->(.+)/s
			? ($1,$2,$3)
			: error("テンプレート不正");

	# レス用テンプレート
	my $resloop;
	open(IN,"$cf{tmpldir}/read_res.html") or error("open err: read_res.html");
	$resloop = join('', <IN>);
	close(IN);

	# ヘッダ表示
	print "Content-type: text/html; charset=utf-8\n\n";
	print $head;
	
	# 記事展開
	my $res;
	foreach (@res) {
		my ($no,$reno,$date,$name,$eml,$sub,$com,$url,$host,$pw,$col,$grad,$lock,$color2) = split(/<>/);

			# レス
			my $tmp = $resloop;
			$tmp =~ s/!art-ttl!/$sub/g;
			$tmp =~ s/!name!/$name/g;
			$tmp =~ s/!url!/$url/g;
			$tmp =~ s/!date!/$date/g;
			$tmp =~ s/!num!/$no/g;
			$tmp =~ s|!comment!|<span style="color:$col">$com</span>|g;
			$tmp =~ s|!icon:(\w+\.\w+)!|<img src="$cf{cmnurl}/$1" alt="" class="icon" />|g;
			$tmp =~ s/!bbs_cgi!/$cf{bbs_cgi}/g;
			$res .= $tmp;
		}

	foreach (@log) {
		my ($no,$reno,$date,$name,$eml,$sub,$com,$url,$host,$pw,$col,$grad,$lock,$color2) = split(/<>/);
		# リンク
			$name = qq|<a href="mailto:$eml">$name</a>| if ($eml);
			$url &&= qq|<a href="$url" target="_blank"><img src="$cf{cmnurl}/home.png" class="icon" alt="" /></a>|;
			$com = auto_link($com) if ($cf{autolink});

		my $tmp = $loop;
		$tmp =~ s/!art-ttl!/$sub/g;
		$tmp =~ s/!name!/$name/g;
		$tmp =~ s/!url!/$url/g;
		$tmp =~ s/!date!/$date/g;
		$tmp =~ s/!num!/$no/g;
		$tmp =~ s/!color2!/$color2/g;
		$tmp =~ s/<!-- res -->/$res/g;
		$tmp =~ s|!comment!|<span style="color:$col[$col]">$com</span>|g;

		if ($lock eq '1') {
			$tmp =~ s|<!-- lock_edit -->.+?<!-- /lock_edit -->||s;
			$tmp =~ s|<!-- lock_form -->.+?<!-- /lock_form -->||s;
		} elsif ($lock == 0 || $lock == '') {
			$tmp =~ s|<!-- lock -->.+?<!-- /lock -->||s;
		}

		print $tmp;
	}

	# フッタ
	footer($foot);
}

#-----------------------------------------------------------
#  投稿フォーム
#-----------------------------------------------------------
sub form_page {

	# クッキー取得
	my @cook = &get_cookie($cf{cookie_id});
	$cook[2] ||= 'http://';

	# 色選択ボタン
	my @col = split(/\s+/, $cf{colors});
	my $color;
	foreach (0 .. $#col) {
		if ($_ == $cook[3]) {
			$color .= qq|<input type="radio" name="color" value="$_" checked>|;
		} else {
			$color .= qq|<input type="radio" name="color" value="$_">|;
		}
		$color .= qq|<span style="color:$col[$_]">■</span>\n|;
	}

	# グラデーションプルダウン
        my @grd = split(/\s+/, $cf{GradStartColor});
        my @grdn = split(/\s+/, $cf{GradName});
	my %ck;
	my $grad;
	if ($cook[4] eq "") { $cook[4] = $grdn[0]; }
	foreach (0 .. $#grd) {
                if ($cook[4] eq $_) {
			$grad .= qq|<option value="$_" style="color:$grd[$_]" selected>$grdn[$_]\n|;
		} else {
			$grad .= qq|<option value="$_" style="color:$grd[$_]">$grdn[$_]\n|;
		}
	}

	# タイトル背景プルダウン
        my @col3 = split(/\s+/, $cf{colors_b});
        my @col4 = split(/\s+/, $cf{colors_b2});
	my $color_b;
	if ($cook[5] eq "") { $cook[5] = $col3[0]; }
	foreach (0 .. $#col3) {
		if ($cook[4] eq $col3[$_]) {
			$color_b .= qq|<option value="$col3[$_]" style="color:$col3[$_]" selected>$col4[$_]</option>\n|;
		} else {
			$color_b .= qq|<option value="$col3[$_]" style="color:$col3[$_]">$col4[$_]</option>\n|;
		}
	}

	# 画像認証作成
	my ($str_plain,$str_crypt,$regikey,$JavaScript);
	if ($cf{use_captcha} > 0) {
		require $cf{captcha_pl};
		($str_plain, $str_crypt, $regikey, $JavaScript) = cap::make( $cf{captcha_key}, $cf{cap_len} );
		$JavaScript=&mkJavaScript($regikey,'myFORM') if($cf{cap_len} == 3);
	}

	open(IN,"$cf{tmpldir}/form.html") or &error("open err: form.html");
	my $tmpl = join('', <IN>);
	close(IN);

	# 文字置換
	$tmpl =~ s/!str_crypt!/$str_crypt/g;
	$tmpl =~ s/!([a-z]+_cgi)!/$cf{$1}/g;
	$tmpl =~ s|!bbs_css!|$cf{cmnurl}/bbs.css|g;
	$tmpl =~ s|!bbs_js!|$cf{cmnurl}/bbs.js|g;
	$tmpl =~ s/!homepage!/$cf{homepage}/g;
	$tmpl =~ s/!bbs_title!/$cf{bbs_title}/g;
	$tmpl =~ s/!name!/$cook[0]/;
	$tmpl =~ s/!email!/$cook[1]/;
	$tmpl =~ s/!url!/$cook[2]/;
	$tmpl =~ s/!sub_len!/$cf{sub_len}/;
	$tmpl =~ s/!color!/$color/g;
	$tmpl =~ s/<!-- op_grad -->/$grad/g;
	$tmpl =~ s/<!-- op_color2 -->/$color_b/g;
	$tmpl =~ s|!icon:(\w+\.\w+)!|<img src="$cf{cmnurl}/$1" alt="" class="icon" />|g;
	$tmpl =~ s|!ico:(\w+\.\w+)!|<img src="$cf{cmnurl}/$1" class="icon">|g;
	$tmpl =~ s/!sub!//g;

	# 画像認証非表示
	if ($cf{use_captcha} == 0) {
		$tmpl =~ s/<!-- captcha_begin -->.+?<!-- captcha_end -->//sg;
	}

	# グラデーションモード
	if ($cf{grad} == 0) {
		$tmpl =~ s/<!-- grad_begin -->.+?<!-- grad_end -->//sg;
	}

	print "Content-type: text/html; charset=utf-8\n\n";
	print $tmpl;

	# フッタ
	footer();

	exit;
}

#-----------------------------------------------------------
#  グラデーションサンプル表示
#-----------------------------------------------------------
sub grad_disp {

	# テンプレート認識
	open(IN,"$cf{tmpldir}/grad_sample.html") or &error("open err: grad_sample.html");
	my $tmpl = join('', <IN>);
	close(IN);

	$tmpl =~ s/!bbs_title!/$cf{bbs_title}/g;
	$tmpl =~ s|!bbs_css!|$cf{cmnurl}/bbs.css|g;
	$tmpl =~ s|!bbs_js!|$cf{cmnurl}/bbs.js|g;

	# テンプレート分割
	my ($head,$loop,$foot);
	if ($tmpl =~ /(.+)<!-- loop_begin -->(.+)<!-- loop_end -->(.+)/s) {
		($head,$loop,$foot) = ($1, $2, $3);
	} else {
		&error("テンプレートが不正です");
	}

	# 文字置換
	foreach ($head, $foot) {
		s/!([a-z]+_cgi)!/$cf{$1}/g;
		s/!version!/$cf{version}/g;
	}

	# 画面展開
	print "Content-type: text/html; charset=utf-8\n\n";
	print $head;

	my @gradcol1;
	my @gradcol2;

	@gradcol1 = split(/\s+/, $cf{GradStartColor});
	@gradcol2 = split(/\s+/, $cf{GradName});
		my $i = 0;
		foreach (0 .. $#gradcol1) {
			$cf{gradnumber} = $i;
			$i++;

		my $grdc = CreatGradation("●●●●●●●●●●●●●●●●●●");

		my $tmp = $loop;
		$tmp =~ s|!gradation!|<div class="grad">$grdc</div>|g;
		$tmp =~ s|!name!|<div class="name"><span style="color:$gradcol1[$_]">$gradcol2[$_]</span></div>|g;
		print $tmp;
	}

	# フッタ
	footer($foot);
	exit;
}

#-----------------------------------------------------------
#  文字列グラデーション化(文字列、開始色、中間色、終了色)
#-----------------------------------------------------------
sub GradStr2{

    my $Str = $_[0];
    my $ColorFrom = $_[1];
    my $ColorIn = $_[2];
    my $ColorTo = $_[3];

    my $Len = Klength($Str);

    my $FromLen = int($Len / 2);
    my $ToLen = $Len - $FromLen;

    my ($FromStr,$i,$ToStr);
    $FromStr = "";
    for($i = 1;$i <= $FromLen;$i++){
        $FromStr = $FromStr . KcharAt($Str, $i);
    }

    $ToStr = "";
    for($i = $FromLen + 1;$i <= $Len;$i++){
        $ToStr = $ToStr . KcharAt($Str, $i);
    }

    if($FromLen == $ToLen){
        $ToStr = KcharAt($FromStr, $FromLen) . $ToStr;
    }else{
        $FromStr = $FromStr . KcharAt($ToStr, 1);
    }

    my $FromTagStr = GradStr($FromStr, $ColorFrom, $ColorIn);
    my $ToTagStr = GradStr($ToStr, $ColorIn, $ColorTo);

    my @S = split(/<\/span>/, $ToTagStr);
    shift(@S);
    $ToTagStr = join("</span>", @S, "");

    return ($FromTagStr . $ToTagStr);
}

#-----------------------------------------------------------
#  文字列グラデーション化(文字列、開始色、終了色)
#-----------------------------------------------------------
sub GradStr{

    my $Str = $_[0];
    my $ColorFrom = $_[1];
    my $ColorTo = $_[2];
    
    my $StaTag = '<span style="color:#';
    my $EndTag = '</span>';

    my $Len = Klength($Str);

    if(substr($ColorFrom, 0, 1) eq "#"){
        $ColorFrom = substr($ColorFrom, 1, 6);
    }
    if(substr($ColorTo, 0, 1) eq "#"){
        $ColorTo = substr($ColorTo, 1, 6);
    }

    my (%Red, %Green, %Blue);
    $Red{'from'} = hex(substr($ColorFrom, 0, 2));
    $Green{'from'} = hex(substr($ColorFrom, 2, 2));
    $Blue{'from'} = hex(substr($ColorFrom, 4, 2));

    $Red{'to'} = hex(substr($ColorTo, 0, 2));
    $Green{'to'} = hex(substr($ColorTo, 2, 2));
    $Blue{'to'} = hex(substr($ColorTo, 4, 2));

    $Red{'level'} = GetLev($Red{'from'}, $Red{'to'}, $Len - 1);
    $Green{'level'} = GetLev($Green{'from'}, $Green{'to'}, $Len - 1);
    $Blue{'level'} = GetLev($Blue{'from'}, $Blue{'to'}, $Len - 1);

    $Red{'color'} = $Red{'from'} - $Red{'level'};
    $Green{'color'} = $Green{'from'} - $Green{'level'};
    $Blue{'color'} = $Blue{'from'} - $Blue{'level'};

    my ($TagStr,$i,$FColor);
    $TagStr = "";
    for ($i = 0 ;$i <= $Len - 1;$i++){
        $Red{'color'} = $Red{'color'} + $Red{'level'};
        $Green{'color'} = $Green{'color'} + $Green{'level'};
        $Blue{'color'} = $Blue{'color'} + $Blue{'level'};
        if ($i < $Len - 1 ){
            $FColor = sprintf("%02X", $Red{'color'}) 
                    . sprintf("%02X", $Green{'color'})
                    . sprintf("%02X", $Blue{'color'})
        } else {
            $FColor = $ColorTo;
        }
        $FColor = lc $FColor;

        $TagStr = $TagStr . $StaTag . $FColor . ';">' . KcharAt($Str, $i + 1) . $EndTag;
    }
    return ($TagStr);
}

#-----------------------------------------------------------
#  グラデーション階調を算出 引数(開始色,終了色,段階)
#-----------------------------------------------------------
sub GetLev{

    my $F = $_[0];
    my $T = $_[1];
    my $n = $_[2];
    my $sa = $T - $F;

    my $am;
    if ($n == 0) {$am = 0;}
    else {$am = $sa % $n; $am = ($sa - $am) / $n;}
    return($am);
}

#-----------------------------------------------------------
#  日本語混在の文字列の長さを取得(UTF-8)(文字列)
#-----------------------------------------------------------
sub Klength{

    my ($text) = @_;

     my $textlen = length($text);
     my $pos = 0;
     my $count = 0;

     while ($pos < $textlen) {
         my $code = ord substr($text, $pos, 1); # 先頭のASCIIコード値を取得
        my $bytelen = _bytesize($code);
         $pos += $bytelen;
         $count++; # 文字数をカウント
    }

     return $count;
}

 # 文字のバイト長を求める
sub _bytesize {
    my ($code) = @_;
     my $size = 1;
     if (0x80 & $code) { # 1バイト文字以外
        $size++;
         $code <<= 1;
         for my $i (2 .. 8) {
             last if (!(0x80 & $code));
             $size++;
             $code <<= 1;
         }
     }
     return $size;
}

#----------------------------------------------------------------------
#  日本語混在の文字列から指定した１文字を取得(UTF-8)(文字列、位置)
#----------------------------------------------------------------------
sub KcharAt{

    my ($src, $offset) = @_;

     my $srclen = length($src);
     my $len = 1;
     my $pos = 0;
     my $count = 1;
     my $dest = '';

     while ($pos < $srclen) {
         my $code = ord substr($src, $pos, 1); # 先頭のASCIIコード値を取得
        my $bytelen = _bytesize($code);
         if (defined($len)){
             if ($count >= $offset && $count < ($offset + $len)) {
                 $dest .= substr($src, $pos, $bytelen);
             }
         }
         $pos += $bytelen;
         $count++; # 文字数をカウント
    }

     return $dest;
}

 # 文字のバイト長を求める
sub _bytesize {
     my $code = shift;
     my $size = 1;
     if (0x80 & $code) { # 1バイト文字以外
        $code <<= 1;
         for my $i (2 .. 8) {
             $size++;
             $code <<= 1;
             last if (!(0x80 & $code));
         }
     }
     return $size;
}

#-------------------------------------------------------
#  グラデーション処理
#-------------------------------------------------------
sub CreatGradation {
    my @NewArr;

    my $OrgStr = $_[0];

    if (!$cf{gradstr}) {
        return $OrgStr;
    }
    $OrgStr =~ s/<BR>/\r/g;
    $OrgStr =~ s/<br>/\r/g;
    $OrgStr =~ s/<br \/>/\r/g;

    my @ArrayStr;
    @ArrayStr = split("\r", $OrgStr);

    my @gscol = split(/\s+/, $cf{GradStartColor});
    my @gmcol = split(/\s+/, $cf{GradMidColor});
    my @gecol = split(/\s+/, $cf{GradEndColor});

    my ($S,@chk,$i,$random,$flg);
    foreach $S (@ArrayStr){
        $i = 0;
        if ($in{randgrad} eq "random") {
            @chk = split(/\s+/, $cf{GradStartColor});
            $random = @chk;
            $i = int(rand($random));
        } elsif($in{gradation} ne '') {
            $i = $in{gradation};
        } else {
            $i = $cf{gradnumber};
            $flg = 1;
        }

        my $BufStr;
        if ($flg) {
        $BufStr = $S;
        $BufStr = GradStr2($BufStr, @gscol[$i], @gmcol[$i], @gecol[$i]);
        $S = $BufStr;
        } else {
            if ($S =~ /^$cf{gradstr}([^\r]*)/){
            	$BufStr = $1;
                $BufStr = GradStr2($BufStr, @gscol[$i], @gmcol[$i], @gecol[$i]);
                $S =~ s/^$cf{gradstr}([^\r]*)/$BufStr/g;
            }
        }
        push(@NewArr,$S);
    }
    return join("<br />", @NewArr);
}

#-----------------------------------------------------------
#  ワード検索
#-----------------------------------------------------------
sub find_data {
	# 条件
	$in{cond} =~ s/\D//g;

	# 検索条件プルダウン
	my %op = (1 => 'AND', 0 => 'OR');
	my $op_cond;
	foreach (1,0) {
		if ($in{cond} eq $_) {
			$op_cond .= qq|<option value="$_" selected="selected">$op{$_}</option>\n|;
		} else {
			$op_cond .= qq|<option value="$_">$op{$_}</option>\n|;
		}
	}

	# 検索実行
	my ($i,@log) = search($cf{logfile}) if ($in{q} ne '');

	# 文字色
	my @col = split(/\s+/,$cf{colors});

	# テンプレート
	open(IN,"$cf{tmpldir}/find.html") or error("open err: find.html");
	my $tmpl = join('', <IN>);
	close(IN);
	
	$tmpl =~ s/!bbs_title!/$cf{bbs_title}/g;
	$tmpl =~ s|!bbs_css!|$cf{cmnurl}/bbs.css|g;
	$tmpl =~ s/!bbs_cgi!/$cf{bbs_cgi}/g;
	$tmpl =~ s/<!-- op_cond -->/$op_cond/;
	$tmpl =~ s/!word!/$in{q}/g;
	$tmpl =~ s|!icon:(\w+\.\w+)!|<img src="$cf{cmnurl}/$1" alt="" class="icon" />|g;

	if ($in{q} eq '') {
		$tmpl =~ s|<!-- find_result -->.+?<!-- /find_result -->||s;
	} else {
		$tmpl =~ s/!result!/$i/;
	}
	
	# 分割
	my ($head,$loop,$foot) = $tmpl =~ /(.+)<!-- loop_begin -->(.+)<!-- loop_end -->(.+)/s
			? ($1,$2,$3)
			: error("テンプレートが不正です");

	# ヘッダ部
	print "Content-type: text/html; charset=utf-8\n\n";
	print $head;

	# ループ部
	foreach my $log (@log) {
		my ($no,$reno,$date,$name,$eml,$sub,$com,$url,$host,$pw,$col,$grad,$lock,$color2) = split(/<>/, $log);
		$name = qq|<a href="mailto:$eml">$name</a>| if ($eml);
		$com  = auto_link($com) if ($cf{autolink});
		$url &&= qq|<a href="$url" target="_blank"><img src="$cf{cmnurl}/home.png" class="icon" alt="" /></a>|;
	# 文字色
	my @col = split(/\s+/,$cf{colors});

		my $tmp = $loop;

	my $dat;
	if ($reno) {
		$tmp =~ s/!art-ttl!//g;

		# 日付フォーマット
		my ($year,$mon,$mday,$wday,$hour,$min) = $date =~ /^(\d{4})\/(\d{2})\/(\d{2})(\w)|(\d{2}):(\d{2})$/ && ($1,$2,$3,$4,$5,$6);
		my ($y,$m,$d) = $date =~ /^(\d+)\/(\d+)\/(\d+)/ && ($1,$2,$3);
		my $week = get_week($y,$m,$d);
		$dat = "$m月$d日（$cf{week}[$week]曜日）$hour:$min";
		$tmp =~ s/!date!/$dat/g;

	} else {
		$tmp =~ s|!art-ttl!|<h3 style="background:$color2;">$sub</h3>|g;
		$tmp =~ s/!date!/$date/g;
	}
		$tmp =~ s/!date!/$date/g;
		$tmp =~ s/!name!/$name/g;
		$tmp =~ s/!url!/$url/g;
		$tmp =~ s/!num!/$no/g;
		$tmp =~ s/!color2!/$color2/g;
		$tmp =~ s|!comment!|<span style="color:$col[$col]">$com</span>|g;

		if ($lock == 0 || $lock == '') {
			$tmp =~ s|<!-- lock -->.+?<!-- /lock -->||s;
		}

		print $tmp;
	}

	# フッタ
	footer($foot);
}

#-----------------------------------------------------------
#  検索実行
#-----------------------------------------------------------
sub search {
	my ($file,$list,$stat) = @_;
	
	# キーワードを配列化
	$in{q} =~ s/　/ /g;
	my @q = split(/\s+/,$in{q});
	
	# UTF-8定義
	my $byte1 = '[\x00-\x7f]';
	my $byte2 = '[\xC0-\xDF][\x80-\xBF]';
	my $byte3 = '[\xE0-\xEF][\x80-\xBF]{2}';
	my $byte4 = '[\xF0-\xF7][\x80-\xBF]{3}';
	
	# 検索処理
	my ($i,@log);
	open(IN,"$file") or error("open err: $file");
	my $top = <IN> if (!$stat);
	while (<IN>) {
		my ($no,$reno,$date,$nam,$eml,$sub,$com,$url,$hos,$pw,$col,$grad,$lock,$color2) = split(/<>/);
		
		my $flg;
		foreach my $q (@q) {
			if ("$nam $eml $sub $com $url" =~ /^(?:$byte1|$byte2|$byte3|$byte4)*?\Q$q\E/i) {
				$flg++;
				if ($in{cond} == 0) { last; }
			} else {
				if ($in{cond} == 1) { $flg = 0; last; }
			}
		}
		next if (!$flg);
		
		$i++;
		if ($list > 0) {
			next if ($i < $in{pg} + 1);
			next if ($i > $in{pg} + $list);
		}
		
		push(@log,$_);
	}
	close(IN);
	
	# 検索結果
	return ($i,@log);
}

#-----------------------------------------------------------
#  留意事項表示
#-----------------------------------------------------------
sub note_page {
	open(IN,"$cf{tmpldir}/note.html") or error("open err: note.html");
	my $tmpl = join('',<IN>);
	close(IN);
	
	$tmpl =~ s/!bbs_title!/$cf{bbs_title}/g;
	$tmpl =~ s|!bbs_css!|$cf{cmnurl}/bbs.css|g;
	$tmpl =~ s|!ico:(\w+\.\w+)!|<img src="$cf{cmnurl}/$1" alt="" class="icon" />|g;
	
	print "Content-type: text/html; charset=utf-8\n\n";
	print $tmpl;
	exit;
}

#-----------------------------------------------------------
#  過去ログ画面
#-----------------------------------------------------------
sub past_log {
	# 過去ログ番号
	open(IN,"$cf{nofile}") or error("open err: $cf{nofile}");
	my $pastnum = <IN>;
	close(IN);
	
	my $pastnum = sprintf("%04d", $pastnum);
	$in{pno} =~ s/\D//g;
	$in{pno} ||= $pastnum;

	# プルダウンタグ作成
	my $op_pno;
	for ( my $i = $pastnum; $i > 0; $i-- ) {
		$i = sprintf("%04d", $i);

		if ($in{pno} == $i) {
			$op_pno .= qq|<option value="$i" selected="selected">$i</option>\n|;
		} else {
			$op_pno .= qq|<option value="$i">$i</option>\n|;
		}
	}

	# ページ数
	my $pg = $in{pg} || 0;

	# 初期化
	my ($hit,$page_btn,$hit,@log,%res);

	# 対象ログ定義
	my $file = "$cf{pastdir}/" . sprintf("%04d", $in{pno}) . ".cgi";

	# ワード検索
	if ($in{find} && $in{word} ne '') {
		# 検索
		($hit,@log) = search($file,$in{list},'past');

		# 結果
		$page_btn = "検索結果：<b>$hit</b>件 &nbsp;&nbsp;" . pgbtn_old($hit,$in{pno},$pg,$in{list},'find');

	# ログ一覧
	} else {
		my $pg_max = $cf{pg_max} * 2;

		# 過去ログオープン
		my $i = 0;
		open(IN,"$file") or error("open err: $file");
		while(<IN>) {
			my ($no,$reno,$date,$nam,$eml,$sub,$com,$url,$hos,$pw,$col,$grad,$lock,$color2) = split(/<>/);

			++$i if ($reno eq '');
			next if ($i < $pg + 1);
			next if ($i > $pg + $pg_max);

			if ($reno) {
				$res{$reno} .= "$no<>$reno<>$date<>$nam<>$eml<>$sub<>$com<>$url<>$col\0";
				next;
			}
			push(@log,$_);
		}
		close(IN);

		# 繰越ボタン作成
		$page_btn = pgbtn_old($i,$in{pno},$pg,$pg_max);
	}

	# プルダウン作成（検索条件）
	my %op = make_op();

	# テンプレート読み込み
	open(IN,"$cf{tmpldir}/past.html") or error("open err: past.html");
	my $tmpl = join('', <IN>);
	close(IN);
	
	open(IN,"$cf{tmpldir}/res.html") or error("open err: res.html");
	my $restmpl = join('', <IN>);
	close(IN);
	
	# 文字置換
	$tmpl =~ s/!bbs_title!/$cf{bbs_title}/g;
	$tmpl =~ s|!bbs_css!|$cf{cmnurl}/bbs.css|g;
	$tmpl =~ s/!past_num!/$in{pno}/g;
	$tmpl =~ s/!bbs_url!//g;
	$tmpl =~ s/!([a-z]+_cgi)!/$cf{$1}/g;
	$tmpl =~ s/<!-- op_pno -->/$op_pno/g;
	$tmpl =~ s/<!-- op_(\w+) -->/$op{$1}/g;
	$tmpl =~ s/!word!/$in{word}/g;
	$tmpl =~ s/!page_btn!/$page_btn/g;
	$tmpl =~ s|!icon:(\w+\.\w+)!|<img src="$cf{cmnurl}/$1" alt="" class="icon" />|g;

	# テンプレート分割
	my ($head,$loop,$foot) = $tmpl =~ /(.+)<!-- loop_begin -->(.+)<!-- loop_end -->(.+)/s
			? ($1,$2,$3)
			: error("テンプレート不正");

	if ($in{change}) { $in{word} = ''; }

	# 文字色
	my @col = split(/\s+/,$cf{colors});

	# 画面表示
	print "Content-type: text/html; charset=utf-8\n\n";
	print $head;
	foreach (@log) {
		my ($no,$reno,$date,$nam,$eml,$sub,$com,$url,$hos,$pw,$col,$grad,$lock,$color2) = split(/<>/);
		$nam = qq|<a href="mailto:$eml">$nam</a>| if ($eml);
		$com = auto_link($com) if ($cf{autolink});
		$url &&= qq|<a href="$url" target="_blank"><img src="$cf{cmnurl}/home.png" class="icon" alt="" /></a>|;

		# レス
		my $res;
		foreach my $log ( split(/\0/, $res{$no}) ) {
			my ($no,$reno,$date,$nam,$eml,$sub,$com,$url,$hos,$pw,$col,$grad) = split(/<>/, $log);
			$nam = qq|<a href="mailto:$eml">$nam</a>| if ($eml);
			$com = auto_link($com) if ($cf{autolink});
			$url &&= qq|<a href="$url" target="_blank"><img src="$cf{cmnurl}/home.png" class="icon" alt="" /></a>|;

			my $tmp = $restmpl;
			$tmp =~ s/!art-ttl!/$sub/g;
			$tmp =~ s/!name!/$nam/g;
			$tmp =~ s/!date!/$date/g;
			$tmp =~ s/!num!/$no/g;
			$tmp =~ s/!url!/$url/g;
			$tmp =~ s|!comment!|<span style="color:$col[$col]">$com</span>|g;
			$tmp =~ s|!icon:(\w+\.\w+)!|<img src="$cf{cmnurl}/$1" alt="" class="icon" />|g;
			$res .= $tmp;
		}

		my $tmp = $loop;
		$tmp =~ s/!art-ttl!/$sub/g;
		$tmp =~ s/!date!/$date/g;
		$tmp =~ s/!name!/$nam/g;
		$tmp =~ s/!url!/$url/g;
		$tmp =~ s|!comment!|<span style="color:$col[$col]">$com</span>|g;
		$tmp =~ s|!icon:(\w+\.\w+)!|<img src="$cf{cmnurl}/$1" alt="" class="icon" />|g;
		$tmp =~ s/!num!/$no/g;
		$tmp =~ s/<!-- res -->/<blockquote>$res<\/blockquote>/g if ($res);
		print $tmp;
	}

	# フッタ
	footer($foot);
}

#-----------------------------------------------------------
#  URLエンコード
#-----------------------------------------------------------
sub url_enc {
	local($_) = @_;

	s/(\W)/'%' . unpack('H2', $1)/eg;
	s/\s/+/g;
	$_;
}

#-----------------------------------------------------------
#  繰越ボタン作成 [ 過去ログ ]
#-----------------------------------------------------------
sub pgbtn_old {
	my ($i,$pno,$pg,$list,$stat) = @_;

	# ページ繰越定義
	my $next = $pg + $list;
	my $back = $pg - $list;

	my $link;
	if ($stat eq 'find') {
		my $wd = url_enc($in{word});
		$link = "$cf{bbs_cgi}?mode=$in{mode}&amp;pno=$pno&amp;find=1&amp;word=$wd&amp;list=$list";
	} else {
		$link = "$cf{bbs_cgi}?mode=$in{mode}&amp;pno=$pno";
	}

	# ページ繰越ボタン作成
	my $pg_btn;
	if ($back >= 0 || $next < $i) {
		$pg_btn .= "Page: ";

		my ($x, $y) = (1, 0);
		while ($i > 0) {
			if ($pg == $y) {
				$pg_btn .= qq(| <b>$x</b> );
			} else {
				$pg_btn .= qq(| <a href="$link&amp;pg=$y">$x</a> );
			}
			$x++;
			$y += $list;
			$i -= $list;
		}
		$pg_btn .= "|";
	}
	return $pg_btn;
}

#-----------------------------------------------------------
#  プルダウン作成 [ 検索条件 ]
#-----------------------------------------------------------
sub make_op {
	my %op;
	my %cond = (1 => 'AND', 0 => 'OR');
	foreach (1,0) {
		if ($in{cond} eq $_) {
			$op{cond} .= qq|<option value="$_" selected="selected">$cond{$_}</option>\n|;
		} else {
			$op{cond} .= qq|<option value="$_">$cond{$_}</option>\n|;
		}
	}
	for ( my $i = 10; $i <= 30; $i += 5 ) {
		if ($in{list} == $i) {
			$op{list} .= qq|<option value="$i" selected="selected">$i件</option>\n|;
		} else {
			$op{list} .= qq|<option value="$i">$i件</option>\n|;
		}
	}
	return %op;
}

#-----------------------------------------------------------
#  カウンタ処理
#-----------------------------------------------------------
sub bbs_count {
	# IP取得
	my $addr = $ENV{REMOTE_ADDR};

	# 閲覧時のみカウントアップ
	my $cntup = $in{mode} eq '' ? 1 : 0;

	# カウントファイルを読みこみ
	open(LOG,"+< $cf{cntfile}") or error("open err: $cf{cntfile}");
	eval "flock(LOG, 2);";
	my $count = <LOG>;

	# IPチェックとログ破損チェック
	my ($cnt,$ip) = split(/:/,$count);
	if ($addr eq $ip or $cnt eq "") { $cntup = 1; }

	# カウントアップ
	if ($cntup) {
		$cnt++;
		seek(LOG, 0, 0);
		print LOG "$cnt:$addr";
		truncate(LOG, tell(LOG));
	}
	close(LOG);

	# 桁数調整
	while(length($cnt) < $cf{mini_fig}) { $cnt = '0' . $cnt; }
	my @cnts = split(//,$cnt);

	# GIFカウンタ表示
	my $counter;
	if ($cf{counter} == 2) {
		foreach (0 .. $#cnts) {
			$counter .= qq|<img src="$cf{gif_path}/$cnts[$_].gif\" alt="$cnts[$_]" />|;
		}

	# テキストカウンタ表示
	} else {
		$counter = qq|<span style="color:$cf{cntcol}">$cnt</span>\n|;
	}
	return $counter;
}

#-----------------------------------------------------------
#  自動リンク
#-----------------------------------------------------------
sub auto_link {
	my $text = shift;

	$text =~ s/(s?https?:\/\/([\w-.!~*'();\/?:\@=+\$,%#]|&amp;)+)/<a href="$1" target="_blank">$1<\/a>/g;
	return $text;
}

#-----------------------------------------------------------
#  フッター
#-----------------------------------------------------------
sub footer {
	my $foot = shift;

	# 著作権表記（削除・改変禁止）
	my $copy = <<EOM;
<div id="footer">
- <a href="https://www.kent-web.com/" target="_top">PETIT BOARD</a> -<br>
	++ <a href="https://www.transformsite.com/" target="_top">Edited by TRANSFORM</a> ++
</div>
EOM

	if ($foot =~ /(.+)(<\/body[^>]*>.*)/si) {
		print "$1$copy$2\n";
	} else {
		print "$foot$copy\n";
		print "</body></html>\n";
	}
	exit;
}

#-----------------------------------------------------------
#  繰越ボタン作成
#-----------------------------------------------------------
sub make_pgbtn {
	my ($i,$pg,$stat) = @_;

	# ページ繰越定義
	$cf{pg_max} ||= 10;
	my $next = $pg + $cf{pg_max};
	my $back = $pg - $cf{pg_max};

	# ページ繰越ボタン作成
	my @pg;
	if ($back >= 0 || $next < $i) {
		my $flg;
		my ($w,$x,$y,$z) = (0,1,0,$i);
		while ($z > 0) {
			if ($pg == $y) {
				$flg++;
				push(@pg,qq!<li><span>$x</span></li>!);
			} else {
				push(@pg,qq!<li><a href="$cf{bbs_cgi}?pg=$y$stat">$x</a></li>!);
			}
			$x++;
			$y += $cf{pg_max};
			$z -= $cf{pg_max};

			if ($flg) { $w++; }
			last if ($w >= 5 && @pg >= 10);
		}
	}
	while( @pg >= 11 ) { shift(@pg); }
	my $ret = join('', @pg);
	if ($back >= 0) {
		$ret = qq!<li><a href="$cf{bbs_cgi}?pg=$back$stat">&laquo;</a></li>\n! . $ret;
	}
	if ($next < $i) {
		$ret .= qq!<li><a href="$cf{bbs_cgi}?pg=$next$stat">&raquo;</a></li>\n!;
	}
	
	# 結果を返す
	return $ret ? qq|<ul class="pager">$ret</ul>| : '';
}

#-----------------------------------------------------------
#  クッキー取得
#-----------------------------------------------------------
sub get_cookie {
	my $cook_id = shift;

	# クッキー取得
	my $cook = $ENV{HTTP_COOKIE};

	# 該当IDを取り出す
	my %cook;
	foreach ( split(/;/,$cook) ) {
		my ($key,$val) = split(/=/);
		$key =~ s/\s//g;
		$cook{$key} = $val;
	}

	# URLデコード
	my @cook;
	foreach ( split(/<>/,$cook{$cook_id}) ) {
		s/%([0-9A-Fa-f][0-9A-Fa-f])/pack("H2", $1)/eg;
		s/[&"'<>]//g;

		push(@cook,$_);
	}
	return @cook;
}

#-----------------------------------------------------------
#  クッキー発行
#-----------------------------------------------------------
sub set_cookie {
	my $cook_id = shift;
	my @data = @_;

	my ($sec,$min,$hour,$mday,$mon,$year,$wday,undef,undef) = gmtime(time + 60*24*60*60);
	my @mon  = qw|Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec|;
	my @week = qw|Sun Mon Tue Wed Thu Fri Sat|;

	# 時刻フォーマット
	my $gmt = sprintf("%s, %02d-%s-%04d %02d:%02d:%02d GMT",
				$week[$wday],$mday,$mon[$mon],$year+1900,$hour,$min,$sec);

	# URLエンコード
	my $cook;
	foreach (@data) {
		s/(\W)/sprintf("%%%02X", unpack("C", $1))/eg;
		$cook .= "$_<>";
	}

	print "Set-Cookie: $cook_id=$cook; expires=$gmt\n";
}



